import { useResource } from "@/modules/resource";
import { AssetItemFile } from "@queenjs-modules/queentree-explorer/objects/fileSystem/assetFiles";
import { Image, List } from "@queenjs/ui";
import { Button } from "ant-design-vue";
import { defineComponent } from "vue";
import { any } from "vue-types";
import LibraryModal from "./LibraryModal";

export default defineComponent({
  setup() {
    const resource = useResource();

    const replaceMat = async () => {
      const res = await resource.showModal<AssetItemFile>(
        <LibraryModal nodeTypes={["matGroupItem", "mat", "packMat"]} />,
        {
          width: "900px",
        }
      );
      console.log("res: ", res);

      const data = await res.getAssetDetail();
      console.log("data: ", data);
    };

    return () => {
      const list = resource.store.currentMats || [];
      return (
        <div class="w-300px flex flex-col">
          <div class="p-15px text-16px text-white border-dark-800 border-0 border-b-1 border-solid">
            组件列表
          </div>
          <List data={list} gap="10px" class="scrollbar flex-1 py-15px px-15px">
            {{
              item: (record: any) => (
                <CompItem record={record} onClick={replaceMat} />
              ),
              loadmore: () => (
                <div class="text-center py-20px text-12px opacity-80">
                  没有更多了
                </div>
              ),
            }}
          </List>
        </div>
      );
    };
  },
});

const CompItem = defineComponent({
  props: {
    record: any().isRequired,
  },
  emits: ["change", "click"],
  setup(props, { emit }) {
    return () => {
      const { record } = props;
      return (
        <div
          class="flex items-center py-6px px-12px rounded-4px"
          style={{ backgroundColor: "#303030" }}
        >
          <Image src={record.thumbnail} class="w-48px rounded-4px" />
          <div class="ml-10px flex-1 mr-5px w-0">{record.name || "未命名"}</div>
          <Button
            ghost
            type="primary"
            size="small"
            onClick={() => emit("click", record)}
          >
            替换
          </Button>
        </div>
      );
    };
  },
});
